<?php

/**
 * @Module Name: 1Pay Payments | WHMCS
 * Plugin URI: http://1pay.in
 * Description: Extends WHMCS with 1Pay services
 * Version: 1.0.3
 * @author: Soumil Gada, Manisha Gupta
 * Author EMAIL: soumil.gada@mobilewaretech.com
 * @copyright: @2018 Mobilewaretech. All rights reserved
 */
class Functions {

    private $ekey = '3a5c1c4e81d7eb133a5c1c4e81d7eb13';

    function get_string_between($string, $start, $end) {
        $string = ' ' . $string;
        $ini = strpos($string, $start);
        if ($ini == 0)
            return '';
        $ini += strlen($start);
        $len = strpos($string, $end, $ini) - $ini;
        return substr($string, $ini, $len);
    }

    function request($url, $postData) {
        $ch = curl_init($url);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

        $data = curl_exec($ch);
        curl_close($ch);
        return json_decode($data);
    }

    function checksum($data) {
        $url = $data['url'] . 'checksumgenerator';
        $myvars = "merchantId=" . $data['merchantId'] . "&txnId=" . $data['txnId'] . "&dateTime=" . $data['dateTime'] . "&amount=" . $data['amount'] . "&apiKey=" . $data['apiKey'] . "&custMobile=" . $data['custMobile'] . "&custMail=" . $data['custMail'] . "&channelId=0&txnType=DIRECT";

        echo $myvars . '\n';
        $checksum = $this->request($url, $myvars);

        return $checksum->checksum;
    }

    function verify($data) {
        $url = $data['url'] . 'getTxnDetails';
        $merchantid = $data['respData']->merchant_id;
        $txnid = $data['respData']->txn_id;
        $myvars = "merchantId=" . $merchantid . "&txnId=" . $txnid . "";

        //$myvars = "respData=" . $data['respData'] . "";


        $resdata = $this->request($url, $myvars);

        return $resdata;
    }

    public function get_encrypt($input) {
        //for php 5.x.x to 7.0.x
        $key = $this->ekey;
        $size = mcrypt_get_block_size(MCRYPT_RIJNDAEL_128, MCRYPT_MODE_ECB);

        $input = $this->get_pkcs5_pad($input, $size);

        $td = mcrypt_module_open(MCRYPT_RIJNDAEL_128, '', MCRYPT_MODE_ECB, '');

        $iv = mcrypt_create_iv(mcrypt_enc_get_iv_size($td), MCRYPT_RAND);

        mcrypt_generic_init($td, $key, $iv);
        $data = mcrypt_generic($td, $input);

        mcrypt_generic_deinit($td);
        mcrypt_module_close($td);
        $data = base64_encode($data);

        //die;
        return $data;
    }

    protected function get_pkcs5_pad($text, $blocksize) {
        $pad = $blocksize - (strlen($text) % $blocksize);
        return $text . str_repeat(chr($pad), $pad);
    }

    public function get_decrypt($input) {
        $key = $this->ekey;
        $decrypted = mcrypt_decrypt(
                MCRYPT_RIJNDAEL_128, $key, base64_decode($input), MCRYPT_MODE_ECB
        );
        $dec_s = strlen($decrypted);
        $padding = ord($decrypted[$dec_s - 1]);
        $decrypted = substr($decrypted, 0, -$padding);


        return $decrypted;
    }

}

?>